#auto_version

#import <shaders/include/text.glsl>

const float STRIKE_MIN_Y = SUPER_PIXEL * 3.0;
const float STRIKE_MAX_Y = SUPER_PIXEL * 4.0;

const float UNDERLINE_MIN_Y = SUPER_PIXEL * 7.0;
const float UNDERLINE_MAX_Y = SUPER_PIXEL * 8.0;

uniform sampler2D Sampler0;

centroid in vec2 vUV;
in float vUVRelY;
in vec4 vColor;
in float vBold;
in float vStrike;
in float vUnderline;

out vec4 fragColor;

void main() {
    bool regularFilled = bool(round(texture(Sampler0, vUV).a));
    bool boldFilled = bool(vBold * round(texture(Sampler0, vUV - vec2(SUPER_PIXEL, 0.0)).a));
    float localTexCoord0Y = mod(vUVRelY, SUPER_PIXEL * float(PIXELS_PER_CHAR));
    bool strikeFilled = bool(vStrike * step(STRIKE_MIN_Y, localTexCoord0Y) * step(-STRIKE_MAX_Y, -localTexCoord0Y));
    bool underlineFilled = bool(vUnderline * step(UNDERLINE_MIN_Y, localTexCoord0Y));
    float filled = float(any(bvec4(regularFilled, boldFilled, strikeFilled, underlineFilled)));
    fragColor = vColor * filled;
}
