#auto_version

#import <shaders/include/instanced.glsl>
#import <shaders/include/rect_offsets.glsl>
#import <shaders/include/text.glsl>

///// Length of the atlas in each dimension.
//const uint ATLAS_LEN_I = SUPER_ATLAS_LEN / PIXELS_PER_CHAR;
//
//const float ATLAS_LEN = float(ATLAS_LEN_I);

//const float UNIT_CHAR_MINUS_ONE_PIXEL = (8.0 - 1e-1) / 8.0;
//const float UNIT_CHAR_MINUS_ONE_PIXEL = (8.0 - 1.0) / 8.0;
const float CHAR_POS_TO_ATLAS_SCALE_FACTOR = 1.0 / float(SUPER_ATLAS_LEN / PIXELS_PER_CHAR);
//const vec2 OFFSET_MULTIPLIER = vec2(1.0, 9.0 / 8.0);
//const vec2 VERT_OFF_TO_ATLAS_SCALE_FACTOR = vec2(UNIT_CHAR_MINUS_ONE_PIXEL, 1.0) * CHAR_POS_TO_ATLAS_SCALE_FACTOR;
//const vec2 VERT_OFF_TO_ATLAS_SCALE_FACTOR = OFFSET_MULTIPLIER * CHAR_POS_TO_ATLAS_SCALE_FACTOR;
//const float VERT_OFF_UV_FACTOR = (8.0 - 1e-1) / 8.0;
const vec2 TEX_OFFSET_BASE = vec2(-0.5 / 8.0, 0.0 / 8.0);
//const vec2 TEX_OFFSET_MULTIPLIER = vec2((8.0 - 0.5) / 8.0, (8.0 - 0.0) / 8.0) - TEX_OFFSET_BASE;
const vec2 TEX_OFFSET_MULTIPLIER = vec2((8.0 - 0.5) / 8.0, (8.0 - 0.0) / 8.0) - TEX_OFFSET_BASE;

/**
 * The factor for conversion from a [0, 256) super atlas offset to the [0, 1) offset used for texture sampling.
 *
 * Not currently used in here, but left here in case of future refactoring.
 */
const uint BASE256_TO_SUPER_ATLAS_PIXELS = SUPER_ATLAS_LEN / uint(256);

// instance attributes
in vec2 Position;
in float Size;
in vec4 Color;
in uint Char;
in uint Flags;
in vec2 UVBase;

/* IIUC, the spec says that it is not required to duplicate the `centroid` modifier here. But apparently Windows
   requires it. */
centroid out vec2 vUV;
out float vUVRelY;
out vec4 vColor;
out float vBold;
out float vStrike;
out float vUnderline;

void main() {
    vec2 offset = Offset * TEX_OFFSET_MULTIPLIER;
//    vec2 localPosition = offset * OFFSET_MULTIPLIER;
    vec2 localPosition = offset;
    if (bool(Flags & FLAG_ITALIC)) {
//    if (false) {
        localPosition -= vec2(offset.y / 4.0, 0.0);
    }
    vec2 pos = Position + (localPosition * Size);
    gl_Position = projectPos(pos);

    applyClip(pos);

    uint ui = Char & uint(15);
    uint vi = Char >> uint(4);
//    uvec2 UVPixels = UVBase * BASE256_TO_SUPER_ATLAS_PIXELS + uvec2(ui, vi) + uvec2(offset) * PIXELS_PER_CHAR;
//    vUV = vec2(UVPixels) * CHAR_POS_TO_ATLAS_SCALE_FACTOR;
//    vUV = vec2(ui, vi) * CHAR_POS_TO_ATLAS_SCALE_FACTOR + offset * VERT_OFF_TO_ATLAS_SCALE_FACTOR;
    vUV = (vec2(ui, vi) + TEX_OFFSET_BASE + offset) * CHAR_POS_TO_ATLAS_SCALE_FACTOR;
//    vUV = (vec2(ui, vi) + offset) * CHAR_POS_TO_ATLAS_SCALE_FACTOR;
    vUVRelY = vUV.y;
    vUV += UVBase;
    vColor = Color;
    vBold = float(bool(Flags & FLAG_BOLD));
    vStrike = float(bool(Flags & FLAG_STRIKE));
    vUnderline = float(bool(Flags & FLAG_UNDERLINE));
}
