package dev.pfaff.altargui;

/**
 * Responsible for maintaining widget state.
 */
public sealed interface StateContext permits GuiContext.StateContextImpl {
	/**
	 * <p>Gets or instantiates a new element and configures it according to the provided widget.
	 *
	 * <p><strong>Note</strong>: unless the key is a {@link dev.pfaff.altargui.Key.Global GlobalKey}, elements are
	 * keyed by the parent key, the {@code key}, and the widget class.
	 */
	<W extends Widget> WidgetInstance<W> getState(WidgetInstance<?> parent, Key.CallSite key, W widget);
}
