package dev.pfaff.altargui.ffi;

public record ExprRect(Expression x, Expression y, Expression width, Expression height) implements IRect<Expression> {
	public static final ExprRect ZERO = new ExprRect(0.0, 0.0, 0.0, 0.0);

	public ExprRect(double x, double y, double width, double height) {
		this(new Expression(x), new Expression(y), new Expression(width), new Expression(height));
	}

	public ExprRect(ToExpression x, ToExpression y, ToExpression width, ToExpression height) {
		this(x.toExpression(), y.toExpression(), width.toExpression(), height.toExpression());
	}

	public ExprRect(VarRect rect) {
		this(rect.x(), rect.y(), rect.width(), rect.height());
	}

	@Override
	public ExprRect withX(Expression x) {
		return new ExprRect(x, y, width, height);
	}

	@Override
	public ExprRect withY(Expression y) {
		return new ExprRect(x, y, width, height);
	}

	@Override
	public ExprRect withWidth(Expression width) {
		return new ExprRect(x, y, width, height);
	}

	@Override
	public ExprRect withHeight(Expression height) {
		return new ExprRect(x, y, width, height);
	}

	// TODO: add eval method
}
