package dev.pfaff.altargui.ffi;

import static dev.pfaff.altargui.ffi.FFI.LaidContext_nDump;
import static dev.pfaff.altargui.ffi.FFI.LaidContext_nGetValue;

public final class FFILaidOutContext {
	public final FFILayoutEngine engine;

	FFILaidOutContext(FFILayoutEngine engine) {
		this.engine = engine;
	}

	/**
	 * @return the value of the variable, or {@value Double#NaN} if it does not have a value.
	 */
	public double getValue(Variable variable) {
		try {
			return (double) LaidContext_nGetValue.invokeExact(engine.address(), variable.raw());
		} catch (Throwable e) {
			throw new RuntimeException(e);
		}
	}

	public void dump() {
		try {
			LaidContext_nDump.invokeExact(engine.address());
		} catch (Throwable e) {
			throw new RuntimeException(e);
		}
	}
}
