package dev.pfaff.altargui.ffi;

import java.util.List;

public record Term(
		Query query,
		double coefficient
) implements ToExpression {
	public Term(Query query) {
		this(query, 1.0);
	}

	@Override
	public Expression toExpression() {
		return new Expression(0.0, List.of(this));
	}

	@Override
	public Term times(double rhs) {
		return new Term(this.query, this.coefficient * rhs);
	}

	@Override
	public Term dividedBy(double rhs) {
		return new Term(this.query, this.coefficient / rhs);
	}

	public Term negate() {
		return new Term(this.query, -this.coefficient);
	}

	@Override
	public String toString() {
		return this.coefficient + "*" + this.query;
	}
}
