package dev.pfaff.altargui.ffi;

public record VarRect(Variable x, Variable y, Variable width, Variable height) implements IRect<Variable> {
	public static VarRect create(FFILayoutEngine engine) {
		return new VarRect(engine.newVariable(), engine.newVariable(), engine.newVariable(), engine.newVariable());
	}

	@Override
	public VarRect withX(Variable x) {
		return new VarRect(x, y, width, height);
	}

	@Override
	public VarRect withY(Variable y) {
		return new VarRect(x, y, width, height);
	}

	@Override
	public VarRect withWidth(Variable width) {
		return new VarRect(x, y, width, height);
	}

	@Override
	public VarRect withHeight(Variable height) {
		return new VarRect(x, y, width, height);
	}

	public Rect getValues(FFILaidOutContext context) {
		return new Rect(
				context.getValue(x()),
				context.getValue(y()),
				context.getValue(width()),
				context.getValue(height())
		);
	}
}
