package dev.pfaff.altargui.ffi;

public sealed interface ViewportSelector permits ViewportSelector.Window, ViewportSelector.Available,
		ViewportSelector.Allocated {
	byte ordinal();

	/**
	 * Selects the window's viewport.
	 */
	record Window() implements ViewportSelector {
		public byte ordinal() {
			return 0;
		}
	}
	/**
	 * Selects the viewport allocated to the element by its parent.
	 */
	record Available() implements ViewportSelector {
		public byte ordinal() {
			return 1;
		}
	}
	/**
	 * Selects the viewport chosen by the element.
	 */
	record Allocated() implements ViewportSelector {
		public byte ordinal() {
			return 2;
		}
	}
}
