package dev.pfaff.altargui.function;

import java.util.function.IntConsumer;

@FunctionalInterface
public interface ByteConsumer extends IntConsumer {
	void accept(byte b);

	@Override
	default void accept(int value) {
		accept((byte)value);
	}

	default ByteConsumer andThen(ByteConsumer after) {
		return b -> {
			this.accept(b);
			after.accept(b);
		};
	}

	@Override
	default ByteConsumer andThen(IntConsumer after) {
		return b -> {
			this.accept(b);
			after.accept(b);
		};
	}
}
