package dev.pfaff.altargui.function;

import java.util.function.IntConsumer;

@FunctionalInterface
public interface CharConsumer extends IntConsumer {
	void accept(char b);

	@Override
	default void accept(int value) {
		accept((char)value);
	}

	default CharConsumer andThen(CharConsumer after) {
		return b -> {
			this.accept(b);
			after.accept(b);
		};
	}

	@Override
	default CharConsumer andThen(IntConsumer after) {
		return b -> {
			this.accept(b);
			after.accept(b);
		};
	}
}
