package dev.pfaff.altargui.improv;

import dev.pfaff.altargui.ffi.*;
import org.jetbrains.annotations.Nullable;

public interface ApplyLayoutContext {
	LayoutContext context();

	default Variable newVariable() {
		return this.context().newVariable();
	}

	default VarRect newVarRect() {
		return this.context().newVarRect();
	}

	void addConstraint(@Nullable String comment, Constraint constraint) throws LayoutException;
	default void addConstraints(@Nullable String comment, Constraint... constraints) throws LayoutException {
		Util.dumpConstraints(comment, constraints);
		for (int i = 0; i < constraints.length; i++) {
			var constraint = constraints[i];
			try {
				this.addConstraint(null, constraint);
			} catch (AddConstraintException e) {
				throw new AddConstraintException(comment, e.index, e.constraint, e.getCause());
			} catch (Throwable e) {
				throw new AddConstraintException(comment, i, constraint, e);
			}
		}
	}

	/**
	 * The space made available to the element by the parent.
	 */
	default @Nullable ExprRect available() {
		return this.context().available();
	}

	default boolean assertions() {
		return this.context().assertions();
	}
}
