package dev.pfaff.altargui.improv.elements;

import dev.pfaff.altargui.improv.*;
import dev.pfaff.altargui.types.Alignment;

public final class ExpandElement {
	public static ConstraintGroup makeAvailableGroup(Element element, String elementTag) {
		var alignComment = elementTag + "[self::align]";
		var fitsComment = elementTag + "[self::fits]";
		return new ConstraintGroup(element, context -> {
			var available = context.available();
			if (available == null) return;
			var viewport = element.allocation();
			context.addConstraints(alignComment,
					Constraints.align(viewport, available, Alignment.Start, Alignment.Start));
			context.addConstraints(fitsComment,
					Constraints.fits(viewport, available, false));
		});
	}

//	public ExpandElement(Context context) {
//		super(context);
//	}
//
//	private final ConstraintGroup groupAvailable = ExpandElement.makeAvailableGroup(this);
//	private final ConstraintGroup groupChild = new ConstraintGroup(this, context -> {
//		var child = this.getChild();
//		if (child == null) return;
//		var childAllocation = child.allocation();
//		var allocation = this.allocation();
//		// require the expand element viewport to be exactly child
//		context.addConstraints(
//				"Expand[self::child]",
//				childAllocation.x().eq(allocation.x()),
//				childAllocation.y().eq(allocation.y()),
//				childAllocation.width().eq(allocation.width()),
//				childAllocation.height().eq(allocation.height())
//		);
//	});
//
//	@Override
//	protected void initializeLayout(LayoutContext context) throws LayoutException {
//		this.groupAvailable.updateImmediately(context);
//		this.groupChild.updateImmediately(context);
//	}
}
