package dev.pfaff.altargui.input;

import java.util.stream.Stream;

public record InputMods(int value) {
	public InputMods {}

	public static InputMods fromGLFW(int value) {
		if ((value & InputMod.REPEAT.bit()) != 0) {
			throw new UnsupportedOperationException("Unexpected modifier bit found set");
		}
		return new InputMods(value);
	}

	public boolean has(InputMod mod) {
		return (this.value & mod.bit()) != 0;
	}

	public InputMods set(InputMod mod) {
		return new InputMods(this.value | mod.bit());
	}

	public InputMods clear(InputMod mod) {
		return new InputMods(this.value & ~mod.bit());
	}

	public Stream<InputMod> stream() {
		return InputMod.VALUES.stream().filter(this::has);
	}
}
