package dev.pfaff.altargui.inspector;

import dev.pfaff.altargui.Inspector;
import dev.pfaff.altargui.Widget;
import org.jetbrains.annotations.NotNull;

import java.util.List;

import static dev.pfaff.altargui.widgets.MultiChildWidget.col;

public record CustomDetailsValueRenderer<T>(ValueRenderer<? super T> custom, ValueRenderer<T> raw) implements ValueRenderer<T> {
    @Override
    public @NotNull Widget build(Inspector inspector, T value) {
        var custom = this.custom.build(inspector, value);
        var raw = this.raw.build(inspector, value);
        return col(List.of(custom, raw));
    }
}
