package dev.pfaff.altargui.inspector;

import java.lang.invoke.MethodHandles;
import java.lang.invoke.MutableCallSite;

import static java.lang.invoke.MethodType.methodType;

public final class DebugLayer {
    public final String name;
    private final MutableCallSite id = new MutableCallSite(methodType(int.class));

    public DebugLayer(String name) {
        this.name = name;
    }

    public DebugLayer(Class<?> clazz) {
        this(clazz.getSimpleName());
    }

    public DebugLayer(Class<?> clazz, String name) {
        this(clazz.getSimpleName() + ' ' + name);
    }

    public int id() {
        try {
            return (int) id.getTarget().invokeExact();
        } catch (Throwable e) {
            throw new RuntimeException(e);
        }
    }

    public void setId(int i) {
        id.setTarget(MethodHandles.constant(int.class, i));
    }
}
