package dev.pfaff.altargui.inspector;

import dev.pfaff.altargui.Inspector;
import dev.pfaff.altargui.Widget;
import org.jetbrains.annotations.NotNull;

public final class DetailedRawObjectValue<T> implements DebugPropertyValue {
    private final ValueRenderer<T> detailed;
    private final @NotNull T value;
    private final ValueRenderer<T> preview;

    DetailedRawObjectValue(ValueRenderer<@NotNull T> detailed,
                                  @NotNull T value,
                                  ValueRenderer<@NotNull T> preview) {
        this.detailed = detailed;
        this.value = value;
        this.preview = preview;
    }

    /**
     * Returns a detailed view of the value.
     */
    public @NotNull Widget buildDetailed(Inspector inspector) {
        return this.detailed.build(inspector, this.value);
    }

    @Override
    public @NotNull Widget buildPreview(Inspector inspector) {
        return this.preview.build(inspector, this.value);
    }
}
