package dev.pfaff.altargui.inspector.renderers;

import dev.pfaff.altargui.inspector.ValueRenderer;
import dev.pfaff.altargui.widgets.TextWidget;

import java.util.Arrays;

import static dev.pfaff.altargui.Inspector.withInspectorFontSize;

public final class EnumValueRenderer {
	public static ValueRenderer<Enum> preview(Class<? extends Enum> clazz) {
		var names = Arrays.stream(clazz.getEnumConstants())
						  .map(value -> withInspectorFontSize(TextWidget.of(STR."\{clazz.getSimpleName()}.\{value.name()}")))
						  .toList();
		return (inspector, value) -> names.get(value.ordinal());
	}
}
