package dev.pfaff.altargui.inspector.renderers;

import dev.pfaff.altargui.inspector.ValueRenderer;
import dev.pfaff.altargui.inspector.ValueRenderers;
import dev.pfaff.altargui.widgets.TextWidget;

import java.lang.reflect.Field;

import static dev.pfaff.altargui.Inspector.withInspectorFontSize;
import static dev.pfaff.altargui.inspector.ValueRenderers.registerExactRenderer;
import static dev.pfaff.altargui.widgets.TrackingWidgets.trackingIdentity;

record FieldNameRenderer(Field field) {
	public static final ValueRenderer<FieldNameRenderer> PREVIEW = (inspector, value) -> trackingIdentity(value, a -> {
		return withInspectorFontSize(TextWidget.of(a.field.getName()));
	});

	public static final ValueRenderer<FieldNameRenderer> DETAILED = ValueRenderer.by(FieldNameRenderer::field,
			ValueRenderers.Kind.Detailed);

	static {
		registerExactRenderer(FieldNameRenderer.class, ValueRenderers.Kind.Preview, PREVIEW);
		registerExactRenderer(FieldNameRenderer.class, ValueRenderers.Kind.Detailed, DETAILED);
	}
}
