package dev.pfaff.altargui.internal.main;

import dev.pfaff.altargui.text.SDFFontUtil;
import dev.pfaff.altargui.resource.PathLoadableResource;
import dev.pfaff.altargui.texture.ResourceLoadableTexture;

import java.io.IOException;
import java.lang.foreign.Arena;
import java.lang.foreign.ValueLayout;
import java.nio.file.Files;
import java.nio.file.Path;

public final class SDFGenerator {
	public static void main(String[] args) throws IOException {
		var pathIn = Path.of(args[0]);
		var pathOut = Path.of(args[1]);
		var imageData = new ResourceLoadableTexture(new PathLoadableResource(pathIn)).load();
		try (var arena = Arena.ofConfined()) {
			var sdf = SDFFontUtil.transparentAndWhiteToSDF(imageData, arena);
			Files.write(pathOut, sdf.pixels().toArray(ValueLayout.JAVA_BYTE));
		}
	}
}
