package dev.pfaff.altargui.internal.render;

import dev.pfaff.glass.opengl.GL;
import dev.pfaff.glass.opengl.GLVersion;
import dev.pfaff.glass.OS;

public final class GLFeatures {
	public final GLVersion glVersion;

	public GLFeatures(GL gl) {
		this.glVersion = GLVersion.get(gl);
	}

	public boolean canUseGlProgramUniformFunctions() {
		// SIGSEGV when using these functions on macOS, so don't.
		if (OS.HOST instanceof OS.macOS) return false;
		return this.glVersion.major() > 4 || (this.glVersion.major() == 4 && this.glVersion.minor() >= 1);
	}
}
