package dev.pfaff.altargui.libimage;

import dev.pfaff.glass.opengl.enums.GLPixelFormat;
import dev.pfaff.glass.opengl.enums.GLPixelType;
import org.jspecify.annotations.Nullable;

import java.util.List;

public enum ExtendedColorType {
	// order matters
	A8,
	L1,
	La1,
	Rgb1,
	Rgba1,
	L2,
	La2,
	Rgb2,
	Rgba2,
	L4,
	La4,
	Rgb4,
	Rgba4,
	L8,
	La8,
	Rgb8,
	Rgba8,
	L16,
	La16,
	Rgb16,
	Rgba16,
	Bgr8,
	Bgra8,
	Rgb32F,
	Rgba32F,
	Cmyk8;

	public static final List<ExtendedColorType> VALUES = List.of(values());

	public final byte value() {
		return (byte) ordinal();
	}

	@Nullable
	public ColorType colorType() {
		return switch (this) {
			case L8 -> ColorType.L8;
			case La8 -> ColorType.La8;
			case Rgb8 -> ColorType.Rgb8;
			case Rgba8 -> ColorType.Rgba8;
			case L16 -> ColorType.L16;
			case La16 -> ColorType.La16;
			case Rgb16 -> ColorType.Rgb16;
			case Rgba16 -> ColorType.Rgba16;
			case Rgb32F -> ColorType.Rgb32F;
			case Rgba32F -> ColorType.Rgba32F;
			default -> null;
		};
	}
}
