package dev.pfaff.altargui.pathfinder;

import dev.pfaff.altargui.pathfinder.fontkit.FKFontRef;

import java.lang.foreign.Arena;
import java.lang.foreign.MemorySegment;

import static dev.pfaff.altargui.pathfinder.Pathfinder.*;

public record PFCanvasFontContextRef(MemorySegment ptr) {
	public FKFontRef getFontByPostscriptName(String name) {
		return new FKFontRef(constructNativeObject(ML_FKFont, ptr -> {
			try (var arena = Arena.ofConfined()) {
				var nameBytes = arena.allocateFrom(name);
				return (int) MH_PFCanvasFontContextGetFontByPostScriptName.invokeExact(this.ptr(),
						nameBytes,
						nameBytes.byteSize() - 1,
						ptr);
			} catch (Throwable e) {
				throw new RuntimeException(e);
			}
		}, ptr -> MH_FKFontDeinit.invokeExact(ptr)));
	}
}
