package dev.pfaff.altargui.pathfinder;

import dev.pfaff.altargui.types.Color;

import java.lang.foreign.Arena;
import java.lang.foreign.MemorySegment;
import java.lang.foreign.ValueLayout;
import java.nio.ByteOrder;

import static dev.pfaff.altargui.pathfinder.Pathfinder.*;
import static java.lang.foreign.ValueLayout.JAVA_INT;

public record PFFillStyleRef(MemorySegment ptr) {

	public static final ValueLayout.OfInt COLOR_LAYOUT = JAVA_INT.withOrder(ByteOrder.BIG_ENDIAN);

	public static PFFillStyleRef createColor(Color color) {
		return new PFFillStyleRef(constructNativeObject(ML_PFFillStyle,
				ptr -> {
					try (var arena = Arena.ofConfined()) {
						var colorBytes = arena.allocateFrom(COLOR_LAYOUT, color.rgba());
						return (int) MH_PFFillStyleInitColor.invokeExact(ptr, colorBytes);
					}
				},
				ptr -> MH_PFFillStyleDeinit.invokeExact(ptr)));
	}
}
