package dev.pfaff.altargui.pathfinder;

import java.lang.foreign.Arena;
import java.lang.foreign.MemorySegment;

import static dev.pfaff.altargui.pathfinder.Pathfinder.MH_PFGLDestFramebufferInitFullWindow;
import static dev.pfaff.altargui.pathfinder.Pathfinder.ML_PFVector2I;
import static java.lang.foreign.ValueLayout.JAVA_INT;

public sealed interface PFGLDestFramebufferInit {
	void init(MemorySegment ptr);

	record FullWindow(int windowWidth, int windowHeight) implements PFGLDestFramebufferInit {
		@Override
		public void init(MemorySegment ptr) {
			try (var arena = Arena.ofConfined()) {
				var size = arena.allocateFrom(JAVA_INT, this.windowWidth, this.windowHeight)
						.asSlice(0, ML_PFVector2I);
				var result = (int) MH_PFGLDestFramebufferInitFullWindow.invokeExact(ptr, size);
				if (result != 0) throw new RuntimeException();
			} catch (Throwable e) {
				throw new RuntimeException(e);
			}

		}
	}
}
