package dev.pfaff.altargui.pathfinder;

import java.lang.foreign.MemorySegment;
import java.lang.foreign.StructLayout;
import java.lang.invoke.MethodHandle;
import java.lang.invoke.VarHandle;

import static dev.pfaff.altargui.pathfinder.Pathfinder.ML_PFScene;
import static dev.pfaff.altargui.util.MethodHandleUtil.withoutBase;
import static java.lang.foreign.MemoryLayout.PathElement.groupElement;
import static java.lang.foreign.MemoryLayout.structLayout;
import static java.lang.foreign.ValueLayout.JAVA_BOOLEAN;
import static java.lang.invoke.MethodHandles.insertArguments;

public record PFSceneRef(MemorySegment internalPtr) implements Ref {
	public static final StructLayout LAYOUT = structLayout(ML_PFScene.withName("scene"), JAVA_BOOLEAN.withName("managed"));
	private static final VarHandle VH_managed = withoutBase(LAYOUT.varHandle(groupElement("managed"))
			.withInvokeExactBehavior());
	private static final MethodHandle MH_slice_scene = insertArguments(LAYOUT.sliceHandle(groupElement("scene")),
			1,
			0L);

	@Override
	public MemorySegment ptr() {
		try {
			return (MemorySegment) MH_slice_scene.invokeExact(this.internalPtr);
		} catch (Throwable e) {
			throw new RuntimeException(e);
		}
	}

	@Override
	public boolean isManaged() {
		return (boolean) VH_managed.getVolatile(this.internalPtr);
	}

	@Override
	public void setManaged(boolean value) {
		VH_managed.setVolatile(this.internalPtr, value);
	}
}
