package dev.pfaff.altargui.pathfinder;

import dev.pfaff.altargui.pathfinder.fontkit.FKFontRef;

import static dev.pfaff.altargui.GuiGlobals.GL;
import static dev.pfaff.altargui.internal.Config.FONT_FAMILY;
import static dev.pfaff.altargui.internal.Config.PATHFINDER_SCENE_PROXY_EXECUTOR;

public final class PathfinderGlobals {
	private static final PFRendererLevel RENDER_MODE = PFRendererLevel.PF_RENDERER_LEVEL_D3D9;

	static {
		Pathfinder.initialize(GL.symbolLookup());
	}

	private static final PFGLDeviceRef device = Pathfinder.createDevice(PFGLVersion.PF_GL_VERSION_GL3);
	private static final PFResourceLoaderRef resourceLoader = Pathfinder.createEmbeddedResourceLoader();
	public static final PFGLRendererRef renderer = PFGLRendererRef.create(device,
			resourceLoader,
			RENDER_MODE,
			new PFGLDestFramebufferInit.FullWindow(800, 600));
	public static final PFCanvasFontContextRef fontContext = Pathfinder.createSystemFontContext();
	public static final PFBuildOptionsRef options = Pathfinder.createBuildOptions();
//	private static final PFCanvasRef canvas = PATHFINDER.createCanvas(fontContext, WIDTH, HEIGHT);
//	private static final PFSceneRef scene = canvas.createScene();
//	private static final PFSceneProxyRef sceneProxy = scene.createProxy(RENDER_MODE);

	public static final PFSceneProxyRef sceneProxy = switch (PATHFINDER_SCENE_PROXY_EXECUTOR) {
		case Sequential -> PFSceneProxyRef.createWithSequentialExecutor(RENDER_MODE);
		case Rayon -> PFSceneProxyRef.createWithRayonExecutor(RENDER_MODE);
	};

	public static final FKFontRef font = fontContext.getFontByPostscriptName(FONT_FAMILY);
}
