package dev.pfaff.altargui.pathfinder.fontkit;

public enum FKCanvasFormat {
	// order is important!
	/**
	 * Premultiplied R8G8B8A8, little-endian.
	 */
	Rgba32((byte) 4),

	/**
	 * R8G8B8, little-endian.
	 */
	Rgb24((byte) 3),

	/**
	 * A8.
	 */
	A8((byte) 1);

	private final byte pixelSizeInBytes;

	FKCanvasFormat(byte bytes) {
		this.pixelSizeInBytes = bytes;
	}

	public final byte value() {
		return (byte) ordinal();
	}

	public final byte pixelSizeInBytes() {
		return this.pixelSizeInBytes;
	}
}
