package dev.pfaff.altargui.render;

import dev.pfaff.altargui.function.InfallibleAutoClosable;
import dev.pfaff.altargui.internal.Config;

import java.io.Closeable;

public abstract class AbstractVertexArrayObject implements Closeable {
	protected final int vertexArrayId;

	public AbstractVertexArrayObject() {
		this.vertexArrayId = GLUtil.glGenVertexArrays();
	}

	public final void bind() {
		GLUtil.glBindVertexArray(this.vertexArrayId);
	}

	public final void unbind() {
		if (Config.GL_ALWAYS_UNBIND) GLUtil.glxUnbindVertexArray();
	}

	public final InfallibleAutoClosable bound() {
		bind();
		return Config.GL_ALWAYS_UNBIND ? GLUtil::glxUnbindVertexArray : () -> {};
	}

	@Override
	public void close() {
		GLUtil.glDeleteVertexArrays(vertexArrayId);
	}
}
