package dev.pfaff.altargui.render;

import dev.pfaff.glass.opengl.enums.GLEnableCap;

public final class GLEnabler {
	private final GLEnableCap cap;
	private boolean state = false;

	public GLEnabler(GLEnableCap cap) {
		this.cap = cap;
	}

	private void reset(boolean state) {
		if (state) {
			GLUtil.glEnable(cap);
		} else {
			GLUtil.glDisable(cap);
		}
	}

	public void reset() {
		reset(state);
	}

	public void set(boolean state) {
		if (this.state != state) {
			reset(this.state = state);
		}
	}

	public void enable() {
		set(true);
	}

	public void disable() {
		set(false);
	}
}
