package dev.pfaff.altargui.render.objects;

import dev.pfaff.altargui.render.RenderObject;
import dev.pfaff.altargui.types.Color;

public sealed abstract class IRectRenderObject extends RenderObject permits RectRenderObject, TexturedRectRenderObject {
	private float x, y, width, height;

	/**
	 * RGBA
	 */
	private int color;

	protected final float getX() {
		return this.x;
	}

	protected final float getY() {
		return this.y;
	}

	protected final float getWidth() {
		return this.width;
	}

	protected final float getHeight() {
		return this.height;
	}

	protected final Color getColor() {
		return Color.fromRgba(this.color);
	}

	public final void updatePosition(float x, float y) {
		this.x = x;
		this.y = y;
	}

	public final void updateSize(float width, float height) {
		this.width = width;
		this.height = height;
	}

	public final void updatePositionSize(float x, float y, float width, float height) {
		updatePosition(x, y);
		updateSize(width, height);
	}

	/**
	 * @param color RGBA
	 */
	public final void updateColor(Color color) {
		this.color = color.rgba();
	}

	@Override
	public final int instanceCount() {
		return 1;
	}

	@Override
	public int size() {
		return (int) instanceLayout().byteSize();
	}
}
