package dev.pfaff.altargui.selector;

import dev.pfaff.altargui.WidgetInstance;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.function.Consumer;

public sealed interface BuiltinSelector extends Selector permits Children, NthElement {
	static void applyNext(@Nullable WidgetInstance element,
						  @NotNull BuiltinSelector selector,
						  Consumer<WidgetInstance> consumer) {
		if (element == null) return;
		var next = selector.next();
		if (next != null) {
			next.select(element, consumer);
		} else {
			consumer.accept(element);
		}
	}

	@Nullable Selector next();

	@Override
	default void select(@Nullable WidgetInstance element, Consumer<@NotNull WidgetInstance> consumer) {
		if (element == null) return;
		element.applyBuiltinSelector(this, consumer);
	}
}
