package dev.pfaff.altargui.selector;

import dev.pfaff.altargui.WidgetInstance;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.function.Consumer;

/**
 * Selects the children of the element recursively.
 */
public record ChildrenRecursive(@Nullable Selector next) implements Selector {
	public ChildrenRecursive {
		if (next == Self.INSTANCE) next = null;
	}

	@Override
	public void select(@Nullable WidgetInstance element, Consumer<@NotNull WidgetInstance> consumer) {
		new Children(next).select(element, consumer);
		Children.NULL_NEXT.select(element, nextElement -> select(nextElement, consumer));
	}
}
