package dev.pfaff.altargui.selector;

import dev.pfaff.altargui.WidgetInstance;
import dev.pfaff.altargui.widgets.IdWidget;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.function.Consumer;

public record HasId(String id, @Nullable Selector next) implements Selector {
	public HasId {
		if (next == Self.INSTANCE) next = null;
	}

	private boolean matches(WidgetInstance element) {
		return element instanceof IdWidget.State idElement && id.equals(idElement.id());
	}

	@Override
	public void select(@Nullable WidgetInstance element, Consumer<@NotNull WidgetInstance> consumer) {
		if (matches(element)) consumer.accept(element);
	}

	@Override
	public @Nullable WidgetInstance selectFirst(@Nullable WidgetInstance element) {
		return selectSingle(element);
	}

	@Override
	public @Nullable WidgetInstance selectSingle(@Nullable WidgetInstance element) {
		return matches(element) ? element : null;
	}
}
