package dev.pfaff.altargui.shader;

import dev.pfaff.glass.opengl.enums.GLVertexAttribIType;
import dev.pfaff.glass.opengl.enums.GLVertexAttribPointerType;

import java.nio.ByteOrder;

public class Attributes {
	public static final VertexAttribSpec ATTRIB_POSITION = new VertexAttribSpec("Position",
			GLVertexAttribPointerType.FLOAT,
			2);
	public static final VertexAttribSpec ATTRIB_SIZE_1 = new VertexAttribSpec("Size",
			GLVertexAttribPointerType.FLOAT,
			1);
	public static final VertexAttribSpec ATTRIB_SIZE_2 = new VertexAttribSpec("Size",
			GLVertexAttribPointerType.FLOAT,
			2);
	public static final VertexAttribSpec ATTRIB_COLOR = new VertexAttribSpec("Color",
			GLVertexAttribPointerType.UNSIGNED_BYTE,
			4).withNormalized().withByteOrder(ByteOrder.BIG_ENDIAN);
	public static final VertexAttribSpec ATTRIB_UV = new VertexAttribSpec("UV",
			GLVertexAttribPointerType.FLOAT,
			2);
	public static final VertexAttribSpec ATTRIB_UV_EXTENT = new VertexAttribSpec("UVExtent",
			GLVertexAttribPointerType.FLOAT,
			2);
	public static final VertexAttribSpec ATTRIB_CHAR = new VertexAttribSpec("Char",
			GLVertexAttribIType.UNSIGNED_BYTE,
			1);
	public static final VertexAttribSpec ATTRIB_FLAGS = new VertexAttribSpec("Flags",
			GLVertexAttribIType.UNSIGNED_BYTE,
			1);
	public static final VertexAttribSpec ATTRIB_UV_BASE = new VertexAttribSpec("UVBase",
			// This works only because
			GLVertexAttribPointerType.UNSIGNED_BYTE,
			2).withNormalized();
}
