package dev.pfaff.altargui.shader;

import dev.pfaff.glass.opengl.enums.GLVertexAttribPointerType;
import dev.pfaff.glass.opengl.enums.IGLVertexAttribPointerType;

/**
 * @param location The attribute location.
 * @param type The type of the element.
 * @param width The lane width of the type.
 * @param offset The offset of the first element in the buffer.
 */
public record VertexAttrib(int location, IGLVertexAttribPointerType type, boolean normalized, int width, int offset) {
	public static final VertexAttrib PADDING_BYTE = new VertexAttrib(-1, GLVertexAttribPointerType.BYTE, false, 1, -1);

	public static final int DIVISOR_PER_VERTEX = 0;
	public static final int DIVISOR_PER_INSTANCE = 1;
}
