package dev.pfaff.altargui.text;

import dev.pfaff.altargui.texture.LoadableTexture;

import java.io.IOException;

public interface Font {
	final int PIXELS_PER_CHAR = 8;
	final int CHARS_PER_ROWCOL = 16;
	final float END_TEX_OFFSET = 1.0f / CHARS_PER_ROWCOL - 0.001f / CHARS_PER_ROWCOL;

	/**
	 * {@code ■}
	 */
	final byte FALLBACK_CHAR = (byte)254;

	LoadableTexture texture();

	float getMinX(char character);

	float getMaxX(char character);

	void reload() throws IOException;

	boolean isLoaded();
}
