package dev.pfaff.altargui.text;

import java.util.List;

import static dev.pfaff.altargui.util.Bits.bit;
import static dev.pfaff.altargui.util.Bits.setBit;

public final class StyleFlags {
	private StyleFlags() {}

	public static final int FLAG_BOLD;
	public static final int FLAG_ITALIC;
	public static final int FLAG_STRIKE;
	public static final int FLAG_UNDERLINE;
	public static final int FLAG_COUNT;

	static {
		int i = 0;
		FLAG_BOLD = i++;
		FLAG_ITALIC = i++;
		FLAG_STRIKE = i++;
		FLAG_UNDERLINE = i++;
		FLAG_COUNT = i;
	}

	public static final List<String> FLAG_NAMES = List.of("bold", "italic", "strike", "underline");

	public static final int REGULAR = 0;
	public static final int BOLD = setBit(REGULAR, FLAG_BOLD);
	public static final int ITALIC = setBit(REGULAR, FLAG_ITALIC);
	public static final int STRIKE = setBit(REGULAR, FLAG_STRIKE);
	public static final int UNDERLINE = setBit(REGULAR, FLAG_UNDERLINE);
	public static final int ALL = BOLD | ITALIC | STRIKE | UNDERLINE;

	public static boolean isBold(int flags) {
		return bit(flags, FLAG_BOLD);
	}

	public static boolean isItalic(int flags) {
		return bit(flags, FLAG_ITALIC);
	}

	public static boolean isStrike(int flags) {
		return bit(flags, FLAG_STRIKE);
	}

	public static boolean isUnderline(int flags) {
		return bit(flags, FLAG_UNDERLINE);
	}
}
