package dev.pfaff.altargui.texture;

import dev.pfaff.altargui.libimage.ColorType;
import dev.pfaff.altargui.libimage.ImageData;
import dev.pfaff.altargui.libimage.ImageInfo;
import dev.pfaff.altargui.types.Color;

import java.lang.foreign.Arena;

import static java.lang.foreign.ValueLayout.JAVA_INT;

public record SinglePixelLoadableTexture(Color color) implements LoadableTexture {
	public static final SinglePixelLoadableTexture WHITE = new SinglePixelLoadableTexture(Color.WHITE);

	@Override
	public ImageData load() {
		var info = new ImageInfo(1, 1, ColorType.Rgba8);
		var pixels = Arena.ofAuto().allocateFrom(JAVA_INT, this.color.abgr());
		return new ImageData(info, pixels);
	}
}
