package dev.pfaff.altargui.types;

public record Tex2d(float u1, float v1, float u2, float v2) {
	public static final Tex2d WHOLE = new Tex2d(0f, 0f, 1f, 1f);

	public Tex2d {
	}

	public static Tex2d fromPixelCoords(int u1_i, int v1_i, int u2_i, int v2_i, int textureWidth, int textureHeight) {
		float u1 = u1_i / (float) textureWidth;
		float v1 = v1_i / (float) textureHeight;
		float u2 = u2_i / (float) textureWidth;
		float v2 = v2_i / (float) textureHeight;
		return new Tex2d(u1, v1, u2, v2);
	}

	public static Tex2d fromPixelExtent(int u, int v, int uExtent, int vExtent, int textureWidth, int textureHeight) {
		return fromPixelCoords(u, v, u + uExtent, v + vExtent, textureWidth, textureHeight);
	}
}
