package dev.pfaff.altargui.uploadables;

import dev.pfaff.altargui.render.Sink;
import dev.pfaff.altargui.types.Color;

import java.lang.foreign.Arena;

public final class UploadableDebugRect implements Uploadable {
	private final UploadableRect rect;
	private final UploadableOutline outline;

	public UploadableDebugRect(Arena arena) {
		this.rect = new UploadableRect(arena);
		this.outline = new UploadableOutline(arena);
		this.rect.updateColor(Color.fromRgba(0x0000FF_55));
		this.outline.updateColor(Color.fromRgba(0x0000FF_FF));
	}

	public void updatePositionAndSize(float x, float y, float width, float height) {
		this.rect.updatePositionSize(x, y, width, height);
		var thickness = 2f;
		this.outline.updatePositionSizeThickness(x,
				y,
				x + width,
				y + height,
				thickness);
	}

	@Override
	public int size() {
		return this.rect.size() + this.outline.size();
	}

	@Override
	public void uploadTo(Sink sink) {
//		var y = new MutableInt(4);
//		activeDebugLayers.stream().forEach(id -> {
//			var program = DEBUG_LAYERS.get(id);
//			var nameWidth = TextWidget.textRenderer.getWidth(program.name);
//			var mat = new Matrix4f();
//			mat.loadIdentity();
//			var y_ = y.v;
//			var nextY = y.v = y_ + 1 + TextWidget.textRenderer.fontHeight + 1;
//			RectWidget.fill(this,
//							0,
//							y_,
//							4 + nameWidth + 4,
//							nextY,
//							RectWidget.GENERIC_HUD_BACKGROUND.colorRgba());
//			TextWidget.paintText(mat, this, program.name, 4, y_ + 1, TextWidget.FONT_SIZING_SCALED, 0.5f, true);
//		});

		this.rect.uploadTo(sink);
		this.outline.uploadTo(sink);
	}
}
