package dev.pfaff.altargui.util;

import java.lang.foreign.MemorySegment;
import java.lang.foreign.ValueLayout;

public final class Bits {
	private Bits() {}

	public static boolean bit(int n, int i) {
		return (n & (1 << i)) != 0;
	}

	public static int setBit(int n, int i) {
		return n | (1 << i);
	}

	public static int unsetBit(int n, int i) {
		return n & ~(1 << i);
	}

	public static int bit(int n, int i, boolean b) {
		return n & ~(1 << i) | ((b ? 1 : 0) << i);
	}

	public static boolean getBit(MemorySegment bits, long i) {
		long byteI = i / Byte.SIZE;
		int bitI = (int)(i % Byte.SIZE);
		byte b = bits.get(ValueLayout.JAVA_BYTE, byteI);
		return bit(b, bitI);
	}

	public static void setBit(MemorySegment bits, long i) {
		long byteI = i / Byte.SIZE;
		int bitI = (int)(i % Byte.SIZE);
		byte b = bits.get(ValueLayout.JAVA_BYTE, byteI);
		bits.set(ValueLayout.JAVA_BYTE, byteI, (byte) setBit(b, bitI));
	}

	public static void unsetBit(MemorySegment bits, long i) {
		long byteI = i / Byte.SIZE;
		int bitI = (int)(i % Byte.SIZE);
		byte b = bits.get(ValueLayout.JAVA_BYTE, byteI);
		bits.set(ValueLayout.JAVA_BYTE, byteI, (byte) unsetBit(b, bitI));
	}

	public static void setBitsInRange(MemorySegment bits, long startIndex, long endIndex) {
		// TODO: optimize
		while (startIndex < endIndex) setBit(bits, startIndex++);
	}

	public static void unsetBitsInRange(MemorySegment bits, long startIndex, long endIndex) {
		// TODO: optimize
		while (startIndex < endIndex) unsetBit(bits, startIndex++);
	}
}
