package dev.pfaff.altargui.util;

import java.util.concurrent.Phaser;

public final class Gate {
	private final Phaser phaser = new Phaser(1);

	public void lock() {
		this.phaser.register();
	}

	public void unlock() {
		this.phaser.arriveAndDeregister();
	}

	public void await() {
		this.phaser.arriveAndAwaitAdvance();
	}

	public void awaitInterruptibly() throws InterruptedException {
		var i = this.phaser.arrive();
		this.phaser.awaitAdvanceInterruptibly(i);
	}
}
