package dev.pfaff.altargui.util;

import org.jspecify.annotations.Nullable;

import java.util.stream.Gatherer;

public final class Gatherers {
	public static <T> Gatherer<T, ?, T> intersperse(T t) {
		return Gatherer.<T, IntersperseState<T>, T>ofSequential(IntersperseState::new,
				Gatherer.Integrator.ofGreedy((state, element, downstream) -> {
					if (state.previous != null) {
						if (!downstream.push(state.previous)) return false;
						if (!downstream.push(t)) return false;
					}
					state.previous = element;
					return true;
				}), (state, downstream) -> {
					if (state.previous != null) {
						downstream.push(state.previous);
					}
				});
	}

	public static final class IntersperseState<T> {
		private @Nullable T previous;
	}
}
