package dev.pfaff.altargui.util;

import java.util.stream.Stream;

public final class StreamUtil {
	@SuppressWarnings("unchecked")
	public static <T> Stream<T> concat(Stream<? extends T> first) {
		return (Stream<T>) first;
	}

	public static <T> Stream<T> concat(Stream<? extends T> first, Stream<? extends T> second) {
		return Stream.concat(first, second);
	}

	@SafeVarargs
	public static <T> Stream<T> concat(Stream<? extends T> first, Stream<? extends T> second, Stream<? extends T>... streams) {
		var stream = concat(first, second);
		for (var next : streams) {
			stream = concat(stream, next);
		}
		return stream;
	}
}
