package dev.pfaff.altargui.util.listenable;

import it.unimi.dsi.fastutil.objects.ObjectArraySet;

import java.util.Set;
import java.util.function.Consumer;

public abstract class AbstractSignal implements Signal {
	private final Set<Object> listeners = new ObjectArraySet<>();

	protected final boolean listen(Object listener) {
		return listeners.add(listener);
	}

	protected final void removeListener(Object listener) {
		listeners.remove(listener);
	}

	protected final void forEachListener(Consumer<Object> consumer) {
		listeners.forEach(consumer);
	}

	protected final void notifyListenersAsRunnable() {
		forEachListener(listener -> ((Runnable) listener).run());
	}

	@Override
	public final ListenerDisposer listen(Runnable listener) {
		listen((Object)listener);
		return () -> removeListener(listener);
	}
}
