package dev.pfaff.altargui.util.listenable;

import java.util.function.Consumer;
import java.util.function.Function;

public record ConstantValue<T>(T value) implements Value<T> {
	@Override
	public T read() {
		return this.value;
	}

	@Override
	public ListenerDisposer listen(Runnable listener) {
		listener.run();
		return () -> {};
	}

	@Override
	public ListenerDisposer listen(Consumer<T> listener) {
		listener.accept(this.value);
		return () -> {};
	}

	@Override
	public <R> Value<R> map(Function<T, R> mapper) {
		return new ConstantValue<>(mapper.apply(this.value));
	}
}
