package dev.pfaff.altargui.util.listenable;

public interface Signal {
	/**
	 * Adds a listener. The listener <em>may</em> not be added again if already added.
	 */
	ListenerDisposer listen(Runnable listener);

	/**
	 * Like {@link #listen}, but the listener is also invoked immediately.
	 */
	default ListenerDisposer listenAndInvoke(Runnable listener) {
		var disposer = listen(listener);
		listener.run();
		return disposer;
	}
}
