package dev.pfaff.altargui.widgets;

import dev.pfaff.altargui.*;
import dev.pfaff.altargui.input.InputKey;
import dev.pfaff.altargui.input.InputMods;
import dev.pfaff.altargui.handlers.KeyPressHandler;
import org.jetbrains.annotations.NotNull;

public record HotKeyWidget(KeyPressHandler handler) implements LeafWidget {
	@Override
	public @NotNull WidgetInstance<HotKeyWidget> instantiate(WidgetInstantiationArgs args) {
		return new State(args);
	}

	private static final class State extends LeafWidget.AbstractState<HotKeyWidget> implements KeyPressHandler {
		private KeyPressHandler handler;

		private State(WidgetInstantiationArgs args) {
			super(args);
		}

		@Override
		public void configure(StateContext stateContext, HotKeyWidget widget, boolean init) {
			handler = widget.handler;
		}

		@Override
		protected void computeStencilLayout(StateContext context) {
			computeFillLayout(this);
		}

		@Override
		protected void computeTraceLayout() {
		}

		@Override
		public void uSpecMount(MountContext context) {
			super.uSpecMount(context);
		}

		@Override
		public boolean keyPressed(InputKey keyCode, int scanCode, InputMods modifiers) {
			return handler.keyPressed(keyCode, scanCode, modifiers);
		}
	}
}
