package dev.pfaff.altargui.widgets;

import dev.pfaff.altargui.*;
import dev.pfaff.altargui.widgets.state.Painter;
import dev.pfaff.altargui.widgets.state.PostPainter;
import org.jetbrains.annotations.NotNull;

public record LayerWidget(Widget child, Layer layer) implements SingleChildWidget {
	@Override
	public @NotNull AbstractState<LayerWidget> instantiate(WidgetInstantiationArgs args) {
		return new State(args);
	}

	private static final class State extends AbstractState<LayerWidget> implements Painter, PostPainter {
		private State(WidgetInstantiationArgs args) {
			super(args);
		}

		@Override
		public void paint(long time, Canvas canvas) {
			canvas.setLayer(Layer.Tooltip);
		}

		@Override
		public void paintPost(long time, Canvas canvas) {
			canvas.setLayer(Layer.Normal);
		}
	}
}
