package dev.pfaff.altargui.widgets;

import dev.pfaff.altargui.Canvas;
import dev.pfaff.altargui.StateContext;
import dev.pfaff.altargui.WidgetInstantiationArgs;
import dev.pfaff.altargui.render.PFCanvasDrawer;
import dev.pfaff.altargui.widgets.state.Painter;
import org.jetbrains.annotations.NotNull;

public record PFCanvasWidget(PFCanvasDrawer drawer) implements LeafWidget {
	@Override
	public @NotNull LeafWidget.AbstractState<PFCanvasWidget> instantiate(WidgetInstantiationArgs args) {
		return new State(args);
	}

	private static final class State extends LeafWidget.AbstractState<PFCanvasWidget> implements Painter {
		private PFCanvasDrawer drawer;

		private State(WidgetInstantiationArgs args) {
			super(args);
		}

		@Override
		public void configure(StateContext stateContext, PFCanvasWidget widget, boolean init) {
			if (this.drawer != widget.drawer) {
				this.drawer = widget.drawer;
			}
		}

		@Override
		protected void computeStencilLayout(StateContext context) {
			computeFillLayout(this);
		}

		@Override
		protected void computeTraceLayout() {
		}

		@Override
		public void paint(long time, Canvas canvas) {
			canvas.upload(this.drawer);
		}
	}
}
