package dev.pfaff.altargui.widgets;

import dev.pfaff.altargui.*;
import dev.pfaff.altargui.widgets.state.Painter;
import dev.pfaff.altargui.render.objects.RectRenderObject;
import org.jetbrains.annotations.NotNull;

import java.util.List;
import java.util.stream.Stream;

public final class TooltipBackgroundWidget implements LeafWidget {
	public static final TooltipBackgroundWidget INSTANCE = new TooltipBackgroundWidget();

	private TooltipBackgroundWidget() {
	}

	@Override
	public @NotNull WidgetInstance instantiate(WidgetInstantiationArgs args) {
		return new State(args);
	}

	private static final class State extends LeafWidget.AbstractState<TooltipBackgroundWidget> implements Painter {
		private static final int RECT_COUNT = 9;

		// TODO: store these in a single flat buffer.
		private final List<RectRenderObject> rects = Stream.generate(RectRenderObject::new).limit(RECT_COUNT).toList();
		private State(WidgetInstantiationArgs args) {
			super(args);
//			rects.get(0).updateColorVerticalGradient(0xf0100010, 0xf0100010);
//			rects.get(1).updateColorVerticalGradient(0xf0100010, 0xf0100010);
//			rects.get(2).updateColorVerticalGradient(0xf0100010, 0xf0100010);
//			rects.get(3).updateColorVerticalGradient(0xf0100010, 0xf0100010);
//			rects.get(4).updateColorVerticalGradient(0xf0100010, 0xf0100010);
//			rects.get(5).updateColorVerticalGradient(0x505000FF, 0x5028007f);
//			rects.get(6).updateColorVerticalGradient(0x505000FF, 0x5028007f);
//			rects.get(7).updateColorVerticalGradient(0x505000FF, 0x505000FF);
//			rects.get(8).updateColorVerticalGradient(0x5028007f, 0x5028007f);
		}

		@Override
		public void configure(StateContext stateContext, TooltipBackgroundWidget widget, boolean init) {
		}

		@Override
		protected void computeStencilLayout(StateContext context) {
			computeFillLayout(this);
		}

		@Override
		protected void computeTraceLayout() {
		}

		@Override
		public void uSpecMount(MountContext context) {
			super.uSpecMount(context);
		}

		@Override
		public void paint(long time, Canvas canvas) {
			float x1 = allocatedX();
			float y1 = allocatedY();
			float x2 = x1 + computedWidth();
			float y2 = y1 + computedHeight();

//			rects.get(0).updateCorners(x1 - 3, y1 - 4, x2 + 3, y1 - 3);
//			rects.get(1).updateCorners(x1 - 3, y2 + 3, x2 + 3, y2 + 4);
//			rects.get(2).updateCorners(x1 - 3, y1 - 3, x2 + 3, y2 + 3);
//			rects.get(3).updateCorners(x1 - 4, y1 - 3, x1 - 3, y2 + 3);
//			rects.get(4).updateCorners(x2 + 3, y1 - 3, x2 + 4, y2 + 3);
//			rects.get(5).updateCorners(x1 - 3, y1 - 3 + 1, x1 - 3 + 1, y2 + 3 - 1);
//			rects.get(6).updateCorners(x2 + 2, y1 - 3 + 1, x2 + 3, y2 + 3 - 1);
//			rects.get(7).updateCorners(x1 - 3, y1 - 3, x2 + 3, y1 - 3 + 1);
//			rects.get(8).updateCorners(x1 - 3, y2 + 2, x2 + 3, y2 + 3);
			if (rects.size() != RECT_COUNT) throw new AssertionError();
			for (int i = 0; i < RECT_COUNT; i++) {
				canvas.upload(rects.get(i));
			}
		}
	}
}
