package dev.pfaff.altargui.widgets;

import dev.pfaff.altargui.StateContext;
import dev.pfaff.altargui.Widget;
import dev.pfaff.altargui.WidgetInstance;
import dev.pfaff.altargui.WidgetInstantiationArgs;
import dev.pfaff.altargui.widgets.state.SingleChildWidgetInstance;
import org.jetbrains.annotations.NotNull;

import java.util.Objects;
import java.util.function.Function;

record TrackingObjectByEqualityWidget<A>(A a, Function<A, ? extends @NotNull Widget> builder) implements Widget {
    @Override
    public @NotNull WidgetInstance<TrackingObjectByEqualityWidget<A>> instantiate(WidgetInstantiationArgs args) {
        return new State<>(args);
    }

    private static final class State<A> extends SingleChildWidgetInstance<TrackingObjectByEqualityWidget<A>> {
        private A a;

        private State(WidgetInstantiationArgs args) {
            super(args);
        }

        @Override
        public void configure(StateContext stateContext, TrackingObjectByEqualityWidget<A> widget, boolean init) {
            if (init || !Objects.equals(a, widget.a)) {
                setChild(stateContext, widget.builder.apply(a = widget.a));
            }
        }
    }
}
